
User Interface - Bug #3021

Bug # 2677 (New): fix drawing and functional differences between P2J GUI and 4GL GUI

MESSAGE with SET clause works incorrectly

03/09/2016 07:28 AM - Igor Skornyakov

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Hynek Cihlar % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: Cleanup and Stabilization for GUI   

billable: No case_num:  

vendor_id: GCD   

Description

History

#1 - 03/09/2016 07:31 AM - Igor Skornyakov

- File aab1.p added

With Progress the attached program displays empty string and accepts ENTER while converted version displays "?" and I was unable to close the

dialog at all in GUI mode (both Swing and Web).

In ChUI mode the "?" still appears but the application reacts correctly on ENTER.

#2 - 04/18/2016 06:25 AM - Hynek Cihlar

The problem with entering the value was resolved by #3061.

#3 - 04/18/2016 06:46 AM - Hynek Cihlar

Please review the fix in 3021a revision 11005.

#4 - 04/18/2016 10:54 AM - Greg Shah

Code Review Task Branch 3021a Revision 11005

I believe this change is incorrect.  The problem has a different cause.  I think the issue is related to us not honoring the difference between UPDATE

and SET.  In UPDATE mode, the ? will appear:

def var txt as char init ?.

message "Edit unknown:" update txt.

 

Result is this:

Edit unknown: ?       

Enter data or press F4 to end.

 

But in SET mode it does not appear:

def var txt as char init ?.

message "Edit unknown:" set txt.
Result:

Edit unknown:         

Enter data or press F4 to end.

 

The reason is that in UPDATE mode there is an implicit DISPLAY which copies from the original variable/field TO the screen buffer.  In SET mode,

this part does not happen.  So the hidden screen buffer should have the default value for the given type.

I suspect the correct code is this:

      // copy initial value in UPDATE mode; unknown value can also be used as initial except for date

      // based variables

      if (!set && !(var.isUnknown() && var instanceof date))

      {

         sb.putWidgetValue(id1, var.duplicate());

      }

#5 - 04/20/2016 12:59 PM - Greg Shah

- Assignee set to Hynek Cihlar

- Status changed from New to WIP

#6 - 04/20/2016 04:24 PM - Hynek Cihlar

3021a revision 11006 contains fix of the fix based on the review. I have tested SET and UPDATE with all data types and both ChUI and GUI and the

proposed change works OK.

I will rebase the branch when it is ready to be merged or regression tested. Please review.

#7 - 04/20/2016 04:33 PM - Greg Shah

Code Review Task Branch 3021a Revision 11006

I'm fine with the changes.

#8 - 04/22/2016 09:53 AM - Greg Shah

Please merge 3021a into 1811u.
#9 - 04/22/2016 03:58 PM - Hynek Cihlar

3021a merged to 1811u revision 11027.

#10 - 04/22/2016 03:59 PM - Hynek Cihlar

- % Done changed from 0 to 100

#11 - 04/22/2016 04:08 PM - Greg Shah

- Status changed from WIP to Closed

- Target version set to Milestone 16

- Start date deleted (03/09/2016)

#12 - 04/22/2016 04:18 PM - Hynek Cihlar

3021a archived as dead.

#13 - 11/16/2016 12:22 PM - Greg Shah

- Target version changed from Milestone 16 to Cleanup and Stabilization for GUI

Files

aab1.p 174 Bytes 03/09/2016 Igor Skornyakov
